/*
 * Created on 2019-08-18 ( Time 17:15:10 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "fiche_control_final"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="fiche_control_final" )
public class FicheControlFinal implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="is_valided_by_controleur_final")
    private Boolean    isValidedByControleurFinal ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_reception")
    private Boolean    isValidedByReception ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_facturation")
    private Boolean    isValidedByFacturation ;

	/*
	 * 
	 */
    @Column(name="observations_controleur_final")
    private String     observationsControleurFinal ;

	/*
	 * 
	 */
    @Column(name="observations_reception")
    private String     observationsReception ;

	/*
	 * 
	 */
    @Column(name="observations_facturation")
    private String     observationsFacturation ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_controleur_final")
    private Date       dateValidationControleurFinal ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_reception")
    private Date       dateValidationReception ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_facturation")
    private Date       dateValidationFacturation ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "ordreReparationId" (column "ordre_reparation_id") is not defined by itself because used as FK in a link 
	// "userControleurFinalId" (column "user_controleur_final_id") is not defined by itself because used as FK in a link 
	// "userReceptionId" (column "user_reception_id") is not defined by itself because used as FK in a link 
	// "userFacturationId" (column "user_facturation_id") is not defined by itself because used as FK in a link 
	// "etatId" (column "etat_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="user_controleur_final_id", referencedColumnName="id")
    private User userControleurFinal       ;
    @ManyToOne
    @JoinColumn(name="etat_id", referencedColumnName="id")
    private Etat etat        ;
    @ManyToOne
    @JoinColumn(name="user_facturation_id", referencedColumnName="id")
    private User userFacturation        ;
    @ManyToOne
    @JoinColumn(name="user_reception_id", referencedColumnName="id")
    private User userReception       ;
    @ManyToOne
    @JoinColumn(name="ordre_reparation_id", referencedColumnName="id")
    private OrdreReparation ordreReparation;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public FicheControlFinal() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : is_valided_by_controleur_final ( BIT ) 
    public void setIsValidedByControleurFinal( Boolean isValidedByControleurFinal ) {
        this.isValidedByControleurFinal = isValidedByControleurFinal;
    }
    public Boolean getIsValidedByControleurFinal() {
        return this.isValidedByControleurFinal;
    }

    //--- DATABASE MAPPING : is_valided_by_reception ( BIT ) 
    public void setIsValidedByReception( Boolean isValidedByReception ) {
        this.isValidedByReception = isValidedByReception;
    }
    public Boolean getIsValidedByReception() {
        return this.isValidedByReception;
    }

    //--- DATABASE MAPPING : is_valided_by_facturation ( BIT ) 
    public void setIsValidedByFacturation( Boolean isValidedByFacturation ) {
        this.isValidedByFacturation = isValidedByFacturation;
    }
    public Boolean getIsValidedByFacturation() {
        return this.isValidedByFacturation;
    }

    //--- DATABASE MAPPING : observations_controleur_final ( TEXT ) 
    public void setObservationsControleurFinal( String observationsControleurFinal ) {
        this.observationsControleurFinal = observationsControleurFinal;
    }
    public String getObservationsControleurFinal() {
        return this.observationsControleurFinal;
    }

    //--- DATABASE MAPPING : observations_reception ( TEXT ) 
    public void setObservationsReception( String observationsReception ) {
        this.observationsReception = observationsReception;
    }
    public String getObservationsReception() {
        return this.observationsReception;
    }

    //--- DATABASE MAPPING : observations_facturation ( TEXT ) 
    public void setObservationsFacturation( String observationsFacturation ) {
        this.observationsFacturation = observationsFacturation;
    }
    public String getObservationsFacturation() {
        return this.observationsFacturation;
    }

    //--- DATABASE MAPPING : date_validation_controleur_final ( DATETIME ) 
    public void setDateValidationControleurFinal( Date dateValidationControleurFinal ) {
        this.dateValidationControleurFinal = dateValidationControleurFinal;
    }
    public Date getDateValidationControleurFinal() {
        return this.dateValidationControleurFinal;
    }

    //--- DATABASE MAPPING : date_validation_reception ( DATETIME ) 
    public void setDateValidationReception( Date dateValidationReception ) {
        this.dateValidationReception = dateValidationReception;
    }
    public Date getDateValidationReception() {
        return this.dateValidationReception;
    }

    //--- DATABASE MAPPING : date_validation_facturation ( DATETIME ) 
    public void setDateValidationFacturation( Date dateValidationFacturation ) {
        this.dateValidationFacturation = dateValidationFacturation;
    }
    public Date getDateValidationFacturation() {
        return this.dateValidationFacturation;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setUserControleurFinal( User userControleurFinal ) {
        this.userControleurFinal = userControleurFinal;
    }
    public User getUserControleurFinal() {
        return this.userControleurFinal;
    }


    public void setEtat( Etat etat ) {
        this.etat = etat;
    }
    public Etat getEtat() {
        return this.etat;
    }


    public void setUserFacturation( User userFacturation ) {
        this.userFacturation = userFacturation;
    }
    public User getUserFacturation() {
        return this.userFacturation;
    }


    public void setUserReception( User userReception ) {
        this.userReception = userReception;
    }
    public User getUserReception() {
        return this.userReception;
    }


    public void setOrdreReparation( OrdreReparation ordreReparation ) {
        this.ordreReparation = ordreReparation;
    }
    public OrdreReparation getOrdreReparation() {
        return this.ordreReparation;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(isValidedByControleurFinal);
        sb.append("|");
        sb.append(isValidedByReception);
        sb.append("|");
        sb.append(isValidedByFacturation);
        // attribute 'observationsControleurFinal' not usable (type = String Long Text)
        // attribute 'observationsReception' not usable (type = String Long Text)
        // attribute 'observationsFacturation' not usable (type = String Long Text)
        sb.append("|");
        sb.append(dateValidationControleurFinal);
        sb.append("|");
        sb.append(dateValidationReception);
        sb.append("|");
        sb.append(dateValidationFacturation);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
